<?
//******************************************************************************
//	Daten von Wetterstation Sainlogic nach IPS
//
//	Packete von Wetterstation auf IPS umleiten
//  https://obrienlabs.net/redirecting-weather-station-data-from-observerip/
// 	Bei mir war es bis jetzt nur 
//	iptables -t nat -A PREROUTING -s xx.xx.xx.xx -p tcp --dport 80 -j DNAT --to-destination x.x.x.x:45000
//	Server Socket anlegen mit Port 45000 ( Beispiel )
//	dort sollten im Debug die Telegramme ankommen
//	Register Variable anlegen mit Ziel diese Script und Instanz der Server Socket.
//	Parent Kategorie anlegen und darin die Variablen so wie im Script benutzt.
//
//******************************************************************************

	if ( $_IPS['TYPE'] == 2 OR $_IPS['VALUE'] == false )
		return;
	
	$debug = false;
	
	$parent = 53274;	// ID  Parent Kategorie
		
	$value = $_IPS['VALUE'];
				
	if ( $debug ) IPS_Logmessage(basename(__FILE__),$value );
 
 	$array = parse_url($value);
	
	$querys = explode("&",$array["query"]);

	// Wunderground 
	if ( substr($querys[0],0,2) == "ID" )
		{	
		foreach($querys as $query)
		{
	
		$item = explode("=",$query);
		
		switch ( $item[0] )
			{
			case "indoortempf"		:	$val = $item[1];
										$val = ($val-32)/1.8;
										$id  = IPS_GetVariableIDByName("Innentemperatur", $parent);
										SetValue($id, $val);
										break;
			case "tempf"			:	$val = $item[1];
										$val = ($val-32)/1.8;
										$id  = IPS_GetVariableIDByName("Aussentemperatur", $parent);
										SetValue($id, $val);
										break;
			case "dewptf"			:	$val = $item[1];
										$val = ($val-32)/1.8;
										$id  = IPS_GetVariableIDByName("Taupunkt", $parent);
										SetValue($id, $val);
										break;
			case "windchillf"		:	$val = $item[1];
										$val = ($val-32)/1.8;
										$id  = IPS_GetVariableIDByName("Windchill", $parent);
										SetValue($id, $val);
										break;
			case "indoorhumidity"	:	$val = $item[1];									
										$id  = IPS_GetVariableIDByName("Innenluftfeuchtigkeit", $parent);
										SetValue($id, $val);
										break;
			case "humidity"			:	$val = $item[1];										
										$id  = IPS_GetVariableIDByName("Aussenluftfeuchtigkeit", $parent);
										SetValue($id, $val);
										break;
			case "windspeedmph"		:	$val = $item[1];										
										$valmph = $val;
										$valms  = $val * 0.44704;
										$valkmh = $val * 1.609344;
										$valkn  = $val * 0.86897624190065;
										$id  = IPS_GetVariableIDByName("Windgeschwindigkeit ( mph )", $parent);
										SetValue($id, $valmph);
										$id  = IPS_GetVariableIDByName("Windgeschwindigkeit ( m/s )", $parent);
										SetValue($id, $valms);
										$id  = IPS_GetVariableIDByName("Windgeschwindigkeit ( km/h )", $parent);
										SetValue($id, $valkmh);
										$id  = IPS_GetVariableIDByName("Windgeschwindigkeit ( kn )", $parent);
										SetValue($id, $valkn);										
										break;
			case "windgustmph"		:	$val = $item[1];	
										$valmph = $val;
										$valms  = $val * 0.44704;									
										$valkmh = $val * 1.609344;
										$valkn  = $val * 0.86897624190065;
										$id  = IPS_GetVariableIDByName("Windboeen ( mph )", $parent);
										SetValue($id, $valmph);
										$id  = IPS_GetVariableIDByName("Windboeen ( m/s )", $parent);
										SetValue($id, $valms);
										$id  = IPS_GetVariableIDByName("Windboeen ( km/h )", $parent);
										SetValue($id, $valkmh);
										$id  = IPS_GetVariableIDByName("Windboeen ( kn )", $parent);
										SetValue($id, $valkn);
										break;

			case "winddir"			:	$val = $item[1];										
										$id  = IPS_GetVariableIDByName("Windrichtung", $parent);
										SetValue($id, $val);
										break;
			case "absbaromin"		:	$val = $item[1];	
										$val = $val/0.02952998751 ;									
										$id  = IPS_GetVariableIDByName("Luftdruck absolut", $parent);
										SetValue($id, $val);
										break;
			case "baromin"			:	$val = $item[1];
										$val = $val/0.02952998751 ;										
										$id  = IPS_GetVariableIDByName("Luftdruck", $parent);
										SetValue($id, $val);
										break;
			case "UV"				:	$val = $item[1];										
										$id  = IPS_GetVariableIDByName("UV Index", $parent);
										SetValue($id, $val);
										break;
			case "solarradiation"	:	$val = $item[1];										
										$id  = IPS_GetVariableIDByName("Sonnenstrahlung", $parent);
										SetValue($id, $val);
										break;
			case "rainin"			:	$val = $item[1];	
										$val = $val * 25.4 ;									
										$id  = IPS_GetVariableIDByName("Niederschlag", $parent);
										SetValue($id, $val);
										break;
			case "dailyrainin"		:	$val = $item[1];	
										$val = $val * 25.4 ;									
										$id  = IPS_GetVariableIDByName("Niederschlag taeglich", $parent);
										SetValue($id, $val);
										break;
			case "weeklyrainin"		:	$val = $item[1];	
										$val = $val * 25.4 ;									
										$id  = IPS_GetVariableIDByName("Niederschlag woechentlich", $parent);
										SetValue($id, $val);
										break;
			case "monthlyrainin"	:	$val = $item[1];	
										$val = $val * 25.4 ;									
										$id  = IPS_GetVariableIDByName("Niederschlag monatlich", $parent);
										SetValue($id, $val);
										break;
			case "softwaretype"		:	$val = $item[1];									
										$id  = IPS_GetVariableIDByName("Firmware", $parent);
										SetValue($id, $val);
										break;
			case "dateutc"			:	$val = $item[1];	
			 							$val = urldecode($val);
										$val = strtotime($val)+date("Z");								
										$id  = IPS_GetVariableIDByName("Timestamp", $parent);
										SetValue($id, $val);
										break;

			default :
									if ( $debug ) IPS_logmessage(basename(__FILE__),"Variable nicht definiert : ".$item[0]. " - " . $item[1]);
			
			}
					
				
		}
		
		
		// Update Wunderground
		$url = explode(" ",$value);
		$url = $url[1].$url[2];
		
		$url = "https://weatherstation.wunderground.com".$url;
		if ( $debug ) IPS_logmessage(basename(__FILE__),$url);
		
		$result = file_get_contents($url);
		if ( $debug ) IPS_logmessage(basename(__FILE__),$result);

		}

	// Update Weathercloud ( nimmt nur alle 10 Minuten dann an dazwischen Fehler bei Aufruf
	if ( substr($querys[0],0,3) == "wid" )
		{				
		$url = explode(" ",$array['query']);
		$url = "http://api.weathercloud.net/v01/set?".$url[0];
		$result = @file_get_contents($url);
		if ( $debug ) IPS_logmessage(basename(__FILE__),$result);

		}				

?>